#include<iostream>
using namespace std;
void quicksort(int a[],int b[],int l, int d)
{
    int i,j;
    i=l;
    j=d;
    if(l>=d)
        return;
    while(j>i)
    {
        while(a[d]>a[i])
            i++;
        while(j>i && a[d]<=a[j])
            j--;
        swap(a[i],a[j]);
        swap(b[i],b[j]);
    }
    swap(a[i],a[d]);
    swap(b[i],b[d]);
    quicksort(a,b,l,i-1);
    quicksort(a,b,i+1,d);
}
int main()
{
    int c,i,n,a[100000],b[100000],k[100000],d=1,maks,mini;
    for(i=1;i<=100000;i++)
        a[i]=0;
    cin>>n;
    for(i=1;i<n;i++)
    {
        cin>>c;
        b[i]=i;
        a[c]++;
        cin>>c;
        a[c]++;
    }
    b[i]=i;
    quicksort(a,b,1,n);
    for(i=(n+1)/2;i<=n;i++){
        k[d]=b[i];
        d++;}
    maks=k[1];
    mini=k[1];
    for(i=2;i<=(n+1)/2;i++)
    {
        if (k[i]>maks)
            maks=k[i];
        if (k[i]<mini)
            mini=k[i];
    }
    cout<<maks-mini<<endl;
}